#ifndef ECVMIMEUTILS
#define ECVMIMEUTILS

#include <string>
#include <set>
#include <ECLogger.h>
#include <vmime/vmime.hpp>
#include "inetmapi.h"

class ECVMIMESender : public ECSender
{
private:

	HRESULT HrMakeRecipientsList(LPADRBOOK lpAdrBook, LPMESSAGE lpMessage, vmime::ref<vmime::message> vmMessage, vmime::mailboxList &recipients, bool bAllowEveryone);
	HRESULT HrExpandGroup(LPADRBOOK lpAdrBook, LPSPropValue lpGroupName, LPSPropValue lpGroupEntryID, vmime::mailboxList &recipients, std::set<std::wstring> &setGroups, std::set<std::wstring> &setRecips, bool bAllowEveryone);
	HRESULT HrAddRecipsFromTable(LPADRBOOK lpAdrBook, IMAPITable *lpTable, vmime::mailboxList &recipients, std::set<std::wstring> &setGroups, std::set<std::wstring> &setRecips, bool bAllowEveryone);

public:
	ECVMIMESender(ECLogger *newlpLogger, std::string strSMTPHost, int port);
	virtual	~ECVMIMESender();

	HRESULT sendMail(LPADRBOOK lpAdrBook, LPMESSAGE lpMessage, vmime::ref<vmime::message> vmMessage, bool bAllowEveryone);
};

#endif
