// -*- Mode: C++; -*-
#ifndef MAPIATTACHMENT_H
#define MAPIATTACHMENT_H

#include <vmime/defaultAttachment.hpp>
#include <string>

class mapiAttachment : public vmime::defaultAttachment
{
public:

	mapiAttachment(vmime::ref <const vmime::contentHandler> data,
				   const vmime::encoding& enc,
				   const vmime::mediaType& type,
				   const std::string& contentid,
				   const vmime::word filename,
				   const vmime::text& desc = vmime::NULL_TEXT,
				   const vmime::word& name = vmime::NULL_WORD);

	void addCharset(vmime::charset ch);

private:

	vmime::word m_filename;
	std::string m_contentid;

	bool m_hasCharset;
	vmime::charset m_charset;

	void generatePart(vmime::ref<vmime::bodyPart> part) const;
};

#endif
