/**
 * @file
 * Free/Busy block list
 *
 * @addtogroup libfreebusy
 * @{
 */

#ifndef ECFBBLOCKLIST_H
#define ECFBBLOCKLIST_H

#include "freebusy.h"
#include <map>

typedef std::map<LONG, FBBlock_1>mapFB;

class ECFBBlockList
{
public:
	ECFBBlockList(void);
	~ECFBBlockList(void);

	void Copy(ECFBBlockList *lpfbBlkList);

	HRESULT Add(FBBlock_1* lpFBBlock);
	HRESULT Next(FBBlock_1* pblk);
	HRESULT Reset();
	HRESULT Skip(LONG items);
	HRESULT Restrict(LONG tmStart, LONG tmEnd);
	void Clear();
	ULONG Size();

	HRESULT Merge(FBBlock_1* lpFBBlock);
	HRESULT GetEndTime(LONG *rtmEnd);
private:
	mapFB			m_FBMap;
	mapFB::iterator	m_FBIter;
	LONG			m_tmRestictStart;
	LONG			m_tmRestictEnd;
	bool			m_bInitIter;
};

#endif // ECFBBLOCKLIST_H
/** @} */
