#ifndef ECCHANNELCLIENT_H
#define ECCHANNELCLIENT_H

#include <string>
#include <vector>

#include "ZarafaCode.h"

class ECChannel;

class ECChannelClient {
public:
	ECChannelClient(const char *szPath, const char *szTokenizer);
	~ECChannelClient();

	ECRESULT DoCmd(const std::string &strCommand, std::vector<std::string> &lstResponse);

protected:
	ECRESULT Connect();
	ECRESULT ConnectSocket();
	ECRESULT ConnectHttp();

	unsigned int m_ulTimeout; ///< Response timeout in second

private:
	std::string m_strTokenizer;
	std::string m_strPath;
	bool m_bSocket;
	unsigned int m_ulPort;
	ECChannel *m_lpChannel;
};

#endif /* ECCHANNELCLIENT_H */
