#ifndef EC_FEATURELIST_H
#define EC_FEATURELIST_H

#include <string>
#include <set>

///< all zarafa features that are checked for access before allowing it
const char* zarafa_features[] = {
	"imap", "pop3"
};

/** 
 * Return a set of all available zarafa features.
 * 
 * @return unique set of feature names
 */
inline std::set<std::string> getFeatures() {
	return std::set<std::string>(zarafa_features, zarafa_features + (sizeof(zarafa_features) / sizeof(*zarafa_features)));
}

#endif
