#ifndef ECInvariantChecker_INCLUDED
#define ECInvariantChecker_INCLUDED

template <typename Type>
class ECInvariantChecker {
public:
	ECInvariantChecker(const Type *p): m_p(p) { m_p->CheckInvariant(); }
	~ECInvariantChecker() { m_p->CheckInvariant(); }
private:
	const Type *m_p;
};

#ifdef DEBUG
#define DEBUG_CHECK_INVARIANT	{this->CheckInvariant();}
#define DEBUG_GUARD				guard __g(this);
#else
#define DEBUG_CHECK_INVARIANT	{}
#define DEBUG_GUARD
#endif

#define DECL_INVARIANT_GUARD(__class)	typedef ECInvariantChecker<__class> guard;
#define DECL_INVARIANT_CHECK			void CheckInvariant() const;
#define DEF_INVARIANT_CHECK(__class)	void __class::CheckInvariant() const

#endif // ndef ECInvariantChecker_INCLUDED
