#ifndef boost_compat_INCLUDED
#define boost_compat_INCLUDED

#include <string>

#include <boost/filesystem.hpp>

#if !defined(BOOST_FILESYSTEM_VERSION) || BOOST_FILESYSTEM_VERSION == 2

static inline std::string path_to_string(const boost::filesystem::path &p) {
    return p.file_string();
}

static inline boost::filesystem::path& remove_filename_from_path(boost::filesystem::path &p) {
    return p.remove_leaf();
}

static inline std::string filename_from_path(const boost::filesystem::path &p) {
    return p.leaf();
}
    
#else

static inline std::string path_to_string(const boost::filesystem::path &p) {
    return p.string();
}

static inline boost::filesystem::path& remove_filename_from_path(boost::filesystem::path &p) {
    return p.remove_filename();
}

static inline std::string filename_from_path(const boost::filesystem::path &p) {
    return p.filename().string();
}
    
#endif

#endif // ndef boost_compat_INCLUDED
